import { ComponentRef, ElementRef, OnChanges, OnDestroy, Renderer2, SimpleChanges, ViewContainerRef } from '@angular/core';
import { Observable, Subscription } from 'rxjs';
import { CgBusyComponent } from './cgBusy.component';
import { CgBusyOptions } from './cgBusy.interface';
import { CgBusyService } from './cgBusy.service';
import { CgBusyDefaults } from './cgBusyDefaults.service';
import * as i0 from "@angular/core";
export declare class CgBusyDirective implements OnChanges, OnDestroy {
    private viewContainer;
    private defaultOptions;
    private renderer;
    private el;
    cgBusy: boolean | number | Promise<any> | Subscription | Observable<any> | (Promise<any> | Subscription | Observable<any>)[];
    cgBusyConfig: CgBusyOptions;
    tracker: CgBusyService;
    fakePromise: Promise<void>;
    fakePromiseResolve: () => void;
    $options: CgBusyOptions;
    $promise: (Promise<any> | Subscription | Observable<any>)[];
    componentRef: ComponentRef<CgBusyComponent>;
    constructor(viewContainer: ViewContainerRef, defaultOptions: CgBusyDefaults, renderer: Renderer2, el: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CgBusyDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<CgBusyDirective, "[cgBusy]", never, { "cgBusy": { "alias": "cgBusy"; "required": false; }; "cgBusyConfig": { "alias": "cgBusyConfig"; "required": false; }; }, {}, never, never, true, never>;
}
